/*  Modules.H    */
/*  14/2/13     */
/*Cette bibliothèque permet d'utiliser
 arduino avec les composants que l'on branche 
 a des endroits choisis a l'avance et 
 des fonctions francisees*/
/*Version 0.1 */

/*Définition des codes à utiliser pour les entrees et sorties*/
#define LED1 13 //*fixe l'utilisation d'une led sur D13
#define LED2 12/* module LED sur D12*/
#define LED3 11/* module LED sur D11*/
#define LED4 10/* module LED sur D10*/
#define BUZZER 3/* module buzzer sur D3*/
#define BP1 8/* module bp, inter ou ils sur D8*/
#define BP2 7/* module bp, inter ou ils sur D7*/
#define BP3 6/* module bp, inter ou ils sur D6*/
#define BP4 5/* module bp, inter ou ils sur D5*/
#define M1A 1/* D1 sur Ma du module L293D*/
#define M1B 0/* D0 sur MB du module L293D*/
#define M2A 4/*moteur 2 */
#define M2B 2 /*moteur 2*/
#define LDR 0/* module LDR sur A0*/
#define TEMPERATURE 2/* module TEMP sur A2*/
#define IR 3/* module Barrierre IR sur A3*/
#define FRAPPE 4/* module capteur de frappe sur A4*/
#define LIGNE1 1 /*suiveur deligne1*/
#define LIGNE2 5 /*suiveur de ligne 2*/
#define CAPTEUR0 0 /*capteur divers sur 0*/
#define CAPTEUR0 1 /*capteur divers sur 1*/
#define CAPTEUR0 2 /*capteur divers sur 2*/
#define CAPTEUR0 3 /*capteur divers sur 3*/
#define CAPTEUR0 4 /*capteur divers sur 4*/
#define CAPTEUR0 5 /*capteur divers sur 5*/


/*Alias des fonctions de la class ou des fonctions de base*/
#define ALLUMER(int) robot.allumer(int)
#define ETEINDRE(int) robot.eteindre(int)
#define PENDANT(int) robot.pendant(int)
#define ATTENDRE delay
#define CLIGNOTER(quoi,millisecondes) robot.clignoter(quoi,millisecondes)
#define INITIALISER() robot.initialiser()
#define	VARIERLED(quoi, valeur) robot.varierled(quoi, valeur)
#define	AVANCER robot.avancer// avec le circuit L293D
#define	RECULER robot.reculer// avec le circuit L293D
#define	ARRET	robot.arret// avec le circuit L293D
#define	GAUCHE robot.gauche// avec le circuit L293D
#define	DROITE robot.droite// avec le circuit L293D
#define	ANGLESERVO(angle) robot.angleservo(angle)
#define	AVANCESERVO robot.avanceservo
#define	RECULESERVO robot.reculeservo
#define GAUCHESERVO robot.gaucheservo
#define DROITESERVO robot.droiteservo
#define	STOPSERVO robot.stopservo
#define	LIRECAPTEUR(quoi) robot.lirecapteur(quoi)
#define	LIRETEMP robot.liretemp
#define	MELODIE robot.melodie 
/*loop et set up*/
#define PARTIE void
#define BOUCLE void
#define CONFIGURATION setup
#define PROGRAMME loop
/*alias des tests*/
#define SI if
#define SINON else
#define SINONSI elseif
#define FAIRE do
#define TANTQUE while
#define REPETER for
/*comparateurs*/
#define SECONDES *1000
#define SECONDE *1000
#define EGALE ==
#define DIFFERENT !=
#define EST == 
#define ET &&
#define OU ||
#define NON !
#define SUPERIEUR >
#define SUPERIEURE >
#define INFERIEUR <
#define INFERIEURE <
#define INFERIEURouEGAL <=
#define SUPERIEURouEGAL >=
//*****Permet de lire les boutons poussoirs de d8 a D5___renvoie la valeur HIGH ou LOW
#define TEST digitalRead
//*****Permet de lire les capteurs analogiques____renvoie la valeur entre 0 et 1023
#define TESTCAPTEUR analogRead
//****traduction des etats
#define ENFONCE HIGH
#define RELACHE LOW
#define VRAI true
#define FAUX false
//***affichage
#define MONITEURSERIE Serial.begin
#define AFFICHE Serial.print
#define RETOURALALIGNE Serial.println

// fonctions et variables de la bibliothèque
#ifndef Modules_H
#define Modules_H
#include <Arduino.h>
#include <Servo.h>

class Modules // Objet
{
    private :
	int etat1; // pour renvoyer l'état des couleurs
	int etat2; // pour renvoyer l'état des couleurs
    public:
	Modules();
	Servo servomoteur;// nom du premier servomoteur 
	Servo servomoteur2; // nom du deuxieme servomoteur
	void allumer(int broche); // pour faire allumer(LED); dans le croquis
	void initialiser(); // pour déclarer les entrées/sorties avant setup ou dedans
	void pendant(int time); // delay simple_inutile car on peut faire sans la class
	void eteindre(int broche);
	void clignoter(int quoi, int millisecondes);
	void varierled(int quoi,int valeur);
	void avancer();// avec le circuit L293D
	void reculer();// avec le circuit L293D
	void arret();// avec le circuit L293D
	void gauche();// avec le circuit L293D
	void droite();// avec le circuit L293D
	void angleservo(int angle); // servomoteur 0_180°
	void avanceservo(); //servomoteur a rotation continue_controle les deux a la fois
	void reculeservo();//servomoteur a rotation continue_controle les deux a la fois
	void gaucheservo();//servomoteur a rotation continue_controle les deux a la fois
	void droiteservo();//servomoteur a rotation continue_controle les deux a la fois
	void stopservo();//servomoteur a rotation continue_controle les deux a la fois
	int lirecapteur(int quoi); //pour les deux capteurs de ligne
	int liretemp();// pour le capteur de temperature lm35
	void melodie();// melodie pre enregistree issue des exemples arduino
};
 #endif